package com.zipcodewilmington;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {

        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {

        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {

        return array[array.length - 1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {

        return array[array.length - 2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {

        boolean contains = Arrays.stream(array).anyMatch(value::equals);
        return  contains;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {
        String[] newArray = new String[array.length];
        int leng = 0;

        for (int i = array.length - 1; i >= 0; i--) {
            newArray[leng] = array[i];
            leng++;
        }

        return newArray;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {


        return Arrays.equals(array, StringArrayUtils.reverse(array));
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {

        String alphaString = Arrays.toString(array).toLowerCase();
        boolean result= false;
             for (char l = 'a'; l <= 'z'; l++) {
                     if (!alphaString.contains(String.valueOf(l))) {
                              result= false;
                     }
                     else {
                         result= true;
                     }
                   }



        return result;
    }

    /**i=
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {

        int count = 0;
        for (int i = 0; i < array.length; i++) {
            if (array[i] == value) {
                count++;

            }
        }
        return count;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {


        String[] newArray = new String[array.length - 1];
        int indexN= 0;
        for (int i = 0; i < array.length; i++) {
            if (!valueToRemove.equals(array[i])) {
                newArray[indexN] = array[i];
                indexN= indexN + 1;
            }

        }
        return newArray;
    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        StringBuilder builder = new StringBuilder();
        String duplicate = "";
        for (String s : array) {
            if (!s.equals(duplicate)) {
                builder.append(s + " ");
            }
            duplicate = s;
        }


    String newArray[] = builder.toString().split(" ");
    return newArray;
}

    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {
        ArrayList<String> arrayList = new ArrayList<>();

        arrayList.add(array[0]);
        for(int i = 1; i < array.length; i++) {
            if(array[i].equals(array[i-1])) {
                String str = arrayList.get(arrayList.size() - 1).concat(array[i]);
                arrayList.set(arrayList.size() - 1, str);
            } else
                {
                    arrayList.add(array[i]);
                 }
                }
                String[] strReturn = arrayList.toArray(new String[arrayList.size()]);
                return strReturn;
           }


}
